#define _WIN32_DCOM // assurer la prsence des dclarations propres  COM
#include "../Commun/Somme_h.h" // dclaration de ISomme
#include "../Commun/UUID_Fabriques.h" // UUID de la fabrique
#include <iostream>
int main ()
{
   HRESULT hr = CoInitializeEx (0, COINIT_APARTMENTTHREADED); // charger COM
   if (FAILED (hr))
   {
      std::cerr << "Echec de CoInitializeEx()" << std::endl;
      return -1;
   }
   IUnknown *pUnk; // instancier le composant et obtenir un IUnknown*
   hr = CoCreateInstance (CLSID_FabriqueSomme, 0, CLSCTX_INPROC_SERVER,
                          IID_IUnknown, reinterpret_cast<void **> (&pUnk));
   if (FAILED (hr)) // erreur lors de l'instanciation du composant
   {
      std::cerr << "Echec de CoCreateInstance(), code " << hr << std::endl;
      CoUninitialize() ;
      return -2;
   }
   ISomme *pSomme; // obtenir le ISomme*
   hr = pUnk->QueryInterface (IID_ISomme, reinterpret_cast<void **> (&pSomme)); 
   pUnk->Release (); // librer le IUnknown*
   if (FAILED (hr))
   {
      std::cerr << "L'interface ISomme n'est pas exposee" << std::endl;
      CoUninitialize() ;
      return -3;
   }
   int LaSomme;
   hr = pSomme->Somme (2, 3, & LaSomme); // utiliser le ISomme*
   if (SUCCEEDED (hr))
      std::cout << "Somme de 2 et de 3 (via ISomme): " << LaSomme << std::endl;
   pSomme -> Release (); // librer le ISomme*
   CoUninitialize (); // dcharger COM
} // main ()
